

ArrayList<PtoLED> ptsLED;
ArrayList<GrpIP> ips;
ArrayList<GrpIP> ipports;
ArrayList<GrpDMX> dmxs;

//ArrayList<Integer> coloresIP;
ArrayList<Integer> coloresDMX;

color[] coloresIP = {
        color(160,160,160),
        color(255,0,0),
        color(0,255,0),
        color(0,0,255),
        color(255,255,0),
        color(0,255,255),
        color(255,0,255),
        color(255,255,255)
  };

int modoDraw = 0;

void setup() {
  size(1024,768);
  smooth();
  
  ptsLED = new ArrayList();
  ips = new ArrayList();
  ipports = new ArrayList();
  dmxs = new ArrayList();
  
  readData();
  
}

void draw() {
  background(0);
  
  switch(modoDraw) {
    case (0):
      drawData();
      break;

    case (1):
      drawIP();
      break;

    case (2):
      drawIPPort();
      break;
      
    case (3):
      drawDMX();
      break;
    
  }
  
  
  // listar IPs
  noStroke();
  fill(200);
//  for(int i=0; i<ips.size(); i++) {
//    String ipt = ips.get(i).ip;
//    text(ipt, 10,15+45*i);      
//  }

  // listar IPPorts
  int xx0 = 10;
  int xport = xx0+150;
  int yy0 = 20;
  int yy = yy0;
  int xx=xx0;
  int lasti = 0;
  int ny = 0;
  String lastIP = "";
  
  fill(0);
  text("IP", xx0, yy0);
  text("Ports", xport, yy0);
  
  fill(220);
  for(int i=0; i<ipports.size(); i++) {
    String ipt = ipports.get(i).ip;
    if(!ipt.equals(lastIP) ) {
      // nueva línea
      yy+=15;
      xx=xx0;
      xport=xx0+150;
      text(ipt, xx, yy);
      lastIP = ipt;
    }
    else {
      // nueva posicion para el puerto
      xport+=25;
    }    
    int pt = ipports.get(i).port;
    text(pt, xport,yy);
  }

  // listar DMXs
  int nCol = 1;
  int itemsCol = 50;
  int x0 = 900;//200;
  for(int i=0; i<dmxs.size(); i++) {
    if(i%itemsCol==0) nCol++;
    text(dmxs.get(i).idDMX, x0 + 30*nCol, 15+15*(i%itemsCol));      
  }
  
  fill(200);
  text("Draw Mode: (p)pts, (i)ip, (d)dmx, (x)ip-ports: "+modoDraw, 10, height-30);
  
}

void readData() {
  new Slurper();
   
  
  
}

void drawData() {
  for(int i=0; i<ptsLED.size(); i++) {
    PtoLED ptl = ptsLED.get(i);
    ptl.draw();
    
  }
}

void drawIP() {
  for(int i=0; i<ips.size(); i++) {
    ips.get(i).draw();   
  }
}

void drawDMX() {
  for(int i=0; i<dmxs.size(); i++) {
    dmxs.get(i).draw();   
  }
}

void drawIPPort() {
  for(int i=0; i<ipports.size(); i++) {
    ipports.get(i).draw();   
  }
}

void keyPressed() {
  switch(key) {
    case 'p': // modo draw Ptos
      modoDraw=0;
      break;
      
    case 'i': // modo draw IP
      modoDraw=1;
      break;

    case 'x': // modo draw IPPorts
      modoDraw=2;
      break;
      
    case 'd': // modo draw DMX
      modoDraw=3;
      break;

    case ' ':
      modoDraw++;
      modoDraw%=4;
      break;
    
  }
}


// = = = 
class PtoLED {
  int x;
  int y;
  
  String ip;
  int port;
  int idDMX;
 
  int masked; 
  
  color c;
  
  PtoLED(String data) {
    
    String[] datitos = data.split(",");
    ip = datitos[0];
    port = Integer.parseInt(datitos[1]);
    idDMX = Integer.parseInt(datitos[2]);
    x = Integer.parseInt(datitos[3]);
    y = Integer.parseInt(datitos[4]);
    
    masked = Integer.parseInt(datitos[5]); 
    
    c = (masked==0)? color(0,255,0):color(255,0,0);
    
  }
  
  void draw() {
    
    noStroke();
    
    if(masked==0) { stroke(c);      fill(c);}
    else          { stroke(255,0,0);     fill(255,0,0);}  // siempre en Rojo

    ellipseMode(CENTER);
    point(x,y);
    
    
  }

  void draw(color cc) {
    stroke(cc);
    fill(cc);
    
    
    ellipseMode(CENTER);
    point(x,y);
    //ellipse(x,y,1,1);
    
    
  }
  
}

// grupos para IP y para DMX

class GrpIP {
  String ip;
  int port;
  ArrayList<PtoLED> ptsLED;
  color c;
  
  GrpIP(String ipt) {
    ip=ipt;
    port = 0;
    ptsLED = new ArrayList();
    c=color(0,255,255);
  }  

  GrpIP(String ipt, int pport) {
    ip=ipt;
    port = pport;
    ptsLED = new ArrayList();
    c=color(0,255,255);
  }  
 
  void addPt(PtoLED pl) {
    ptsLED.add(pl);
  } 
  
  void draw() {
    for(int i=0; i<ptsLED.size(); i++) {
      PtoLED plt = ptsLED.get(i);
      plt.draw(c);
    }
  }
}

class GrpDMX {
  int idDMX;
  ArrayList<PtoLED> ptsLED;
  color c;
  
  GrpDMX(int id) {
    idDMX=id;
    ptsLED = new ArrayList();
    c=color(255,0,255);
  }  
 
  void addPt(PtoLED pl) {
    ptsLED.add(pl);
  } 
  
  void draw() {
    for(int i=0; i<ptsLED.size(); i++) {
      PtoLED plt = ptsLED.get(i);
      plt.draw(c);
    }
  }
}
