// Code from Visualizing Data, First Edition, Copyright 2008 Ben Fry.

class Slurper implements Runnable {

  Slurper() {
    Thread thread = new Thread(this);
    thread.start();
  }

  public void run() {
    try {
      InputStream input = openStream("datos.txt");
      BufferedReader reader = createReader(input);
      
      // first get the info line
      String line = reader.readLine();

      // parse each of the rest of the lines
      while ((line = reader.readLine()) != null) {
        ptsLED.add(new PtoLED(line));
      }
      
      // Una vez cargados los datos:
        // obtener diferentes IPs, IP-port, y DMXs
        for(int i=0; i<ptsLED.size(); i++) {
          PtoLED ptl = ptsLED.get(i);
          
          boolean bIpNew = true;
          for(int j=0; j<ips.size(); j++) {
            String ipt = ips.get(j).ip;
            if(ptl.ip.equals(ipt)) {
              ips.get(j).addPt(ptl);
              bIpNew = false;
              break;
            }
          }
          
          if(bIpNew) {
            // crear nuevo grupo-IP
            GrpIP gip = new GrpIP(ptl.ip);
            ips.add(gip);
            gip.c = coloresIP[ips.size()-1];
            
            gip.addPt(ptl);
          }

// ****
          boolean bIpPortNew = true;
          for(int j=0; j<ipports.size(); j++) {
            String ipt = ipports.get(j).ip;
            int portt = ipports.get(j).port;
            if(ptl.ip.equals(ipt) && ptl.port == portt) {
              ipports.get(j).addPt(ptl);
              bIpPortNew = false;
              break;
            }
          }
          if(bIpPortNew) {
            // crear nuevo grupo-IPPort
            GrpIP gipp = new GrpIP(ptl.ip, ptl.port);
            ipports.add(gipp);
            gipp.c = coloresIP[(ipports.size()-1)%coloresIP.length];
            
            gipp.addPt(ptl);
          }


            boolean bDMXNew = true;
            for(int j=0; j<dmxs.size(); j++) {
              int dmxt = dmxs.get(j).idDMX;
              if(ptl.idDMX==dmxt) {
                dmxs.get(j).addPt(ptl);
                bDMXNew = false;
                break;
              }
            }
            if(bDMXNew) {
              // crear nuevo grupo-DMX
              GrpDMX gdmx = new GrpDMX(ptl.idDMX);
              dmxs.add(gdmx);
              
//              int idxColor = (dmxs.size()-1)%coloresIP.length;
//              gdmx.c = coloresIP[idxColor];
              
              colorMode(HSB,360,100,100);
              gdmx.c = color(floor(dmxs.size()/50.0*360.0),100,100);
              colorMode(RGB,255);
              
              gdmx.addPt(ptl);
              
              
            }
            
            
            
          }
          
          
          println("Num de IPs diferentes: "+ips.size());
          println("Num de DMXs diferentes: "+dmxs.size());

      
      
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
}


